import Conductor from 'conductor-node';const conductor = new Conductor({ apiKey: process.env['CONDUCTOR_SECRET_KEY'], // This is the default and can be omitted});const salesOrder = await conductor.qbd.salesOrders.update('123ABC-1234567890', { revisionNumber: '1721172183', conductorEndUserId: 'end_usr_1234567abcdefg',});console.log(salesOrder.id);
import os
from conductor import Conductor
conductor = Conductor(
api_key=os.environ.get("CONDUCTOR_SECRET_KEY"), # This is the default and can be omitted
)
sales_order = conductor.qbd.sales_orders.update(
id="123ABC-1234567890",
revision_number="1721172183",
conductor_end_user_id="end_usr_1234567abcdefg",
)
print(sales_order.id)
NOTE: If you include lines or lineGroups, QuickBooks Desktop replaces each included line list with the array you send, so include unchanged lines you want to keep and use id: "-1" for new lines.
POST
/
quickbooks-desktop
/
sales-orders
/
{id}
JavaScript
import Conductor from 'conductor-node';const conductor = new Conductor({ apiKey: process.env['CONDUCTOR_SECRET_KEY'], // This is the default and can be omitted});const salesOrder = await conductor.qbd.salesOrders.update('123ABC-1234567890', { revisionNumber: '1721172183', conductorEndUserId: 'end_usr_1234567abcdefg',});console.log(salesOrder.id);
import os
from conductor import Conductor
conductor = Conductor(
api_key=os.environ.get("CONDUCTOR_SECRET_KEY"), # This is the default and can be omitted
)
sales_order = conductor.qbd.sales_orders.update(
id="123ABC-1234567890",
revision_number="1721172183",
conductor_end_user_id="end_usr_1234567abcdefg",
)
print(sales_order.id)
The current QuickBooks-assigned revision number of the sales order object you are updating, which you can get by fetching the object first. Provide the most recent revisionNumber to ensure you're working with the latest data; otherwise, the update will return an error.
The sales order's class. Classes can be used to categorize objects into meaningful segments, such as department, location, or type of work. In QuickBooks, class tracking is off by default. A class defined here is automatically used in this sales order's line items unless overridden at the line item level.
The case-sensitive user-defined reference number for this sales order, which can be used to identify the transaction in QuickBooks. This value is not required to be unique and can be arbitrarily changed by the QuickBooks user.
The customer's Purchase Order (PO) number associated with this sales order. This field is often used to cross-reference the sales order with the customer's purchasing system.
The origin location from where the product associated with this sales order is shipped. This is the point at which ownership and liability for goods transfer from seller to buyer. Internally, QuickBooks uses the term "FOB" for this field, which stands for "freight on board". This field is informational and has no accounting implications.
The sales-tax item used to calculate the actual tax amount for this sales order's transactions by applying a specific tax rate collected for a single tax agency. Unlike salesTaxCode, which only indicates general taxability, this field drives the actual tax calculation and reporting.
The sales-tax code for this sales order, determining whether it is taxable or non-taxable. This can be overridden at the transaction-line level.
Default codes include "Non" (non-taxable) and "Tax" (taxable), but custom codes can also be created in QuickBooks Desktop. If QuickBooks Desktop is not set up to charge sales tax (via the "Do You Charge Sales Tax?" preference), it assigns the default non-taxable sales-tax code configured in the company file to all sales.
A built-in custom field for additional information specific to this sales order. Unlike the user-defined fields in the customFields array, this is a standard QuickBooks field that exists for all sales orders for convenience. Developers often use this field for tracking information that doesn't fit into other standard QuickBooks fields. Unlike otherCustomField1 and otherCustomField2, which are line item fields, this exists at the transaction level. Hidden by default in the QuickBooks UI.
The market exchange rate between this sales order's currency and the home currency in QuickBooks at the time of this transaction. Represented as a decimal value (e.g., 1.2345 for 1 EUR = 1.2345 USD if USD is the home currency).
The sales order's line items, each representing a single product or service ordered.
IMPORTANT:
Including this array in your update request will REPLACE all existing line items for the sales order with this array. To keep any existing line items, you must include them in this array even if they have not changed. Any line items not included will be removed.
To add a new line item, include it here with the id field set to -1.
If you do not wish to modify any line items, omit this field entirely to keep them unchanged.
The sales order's line item groups, each representing a predefined set of related items.
IMPORTANT:
Including this array in your update request will REPLACE all existing line item groups for the sales order with this array. To keep any existing line item groups, you must include them in this array even if they have not changed. Any line item groups not included will be removed.
To add a new line item group, include it here with the id field set to -1.
If you do not wish to modify any line item groups, omit this field entirely to keep them unchanged.
The date and time when this sales order was created, in ISO 8601 format (YYYY-MM-DDThh:mm:ss±hh:mm), which QuickBooks Desktop interprets in the local timezone of the end-user's computer.
The date and time when this sales order was last updated, in ISO 8601 format (YYYY-MM-DDThh:mm:ss±hh:mm), which QuickBooks Desktop interprets in the local timezone of the end-user's computer.
The current QuickBooks-assigned revision number of this sales order object, which changes each time the object is modified. When updating this object, you must provide the most recent revisionNumber to ensure you're working with the latest data; otherwise, the update will return an error.
The sales order's class. Classes can be used to categorize objects into meaningful segments, such as department, location, or type of work. In QuickBooks, class tracking is off by default. A class defined here is automatically used in this sales order's line items unless overridden at the line item level.
The case-sensitive user-defined reference number for this sales order, which can be used to identify the transaction in QuickBooks. This value is not required to be unique and can be arbitrarily changed by the QuickBooks user.
The customer's Purchase Order (PO) number associated with this sales order. This field is often used to cross-reference the sales order with the customer's purchasing system.
The origin location from where the product associated with this sales order is shipped. This is the point at which ownership and liability for goods transfer from seller to buyer. Internally, QuickBooks uses the term "FOB" for this field, which stands for "freight on board". This field is informational and has no accounting implications.
The sales-tax item used to calculate the actual tax amount for this sales order's transactions by applying a specific tax rate collected for a single tax agency. Unlike salesTaxCode, which only indicates general taxability, this field drives the actual tax calculation and reporting.
Show child attributes
Example:
{ "id": "80000001-1234567890", "fullName": "State Sales Tax" }
The sales order's currency. For built-in currencies, the name and code are standard ISO 4217 international values. For user-defined currencies, all values are editable.
The market exchange rate between this sales order's currency and the home currency in QuickBooks at the time of this transaction. Represented as a decimal value (e.g., 1.2345 for 1 EUR = 1.2345 USD if USD is the home currency).
The sales-tax code for this sales order, determining whether it is taxable or non-taxable. This can be overridden at the transaction-line level.
Default codes include "Non" (non-taxable) and "Tax" (taxable), but custom codes can also be created in QuickBooks Desktop. If QuickBooks Desktop is not set up to charge sales tax (via the "Do You Charge Sales Tax?" preference), it assigns the default non-taxable sales-tax code configured in the company file to all sales.
A built-in custom field for additional information specific to this sales order. Unlike the user-defined fields in the customFields array, this is a standard QuickBooks field that exists for all sales orders for convenience. Developers often use this field for tracking information that doesn't fit into other standard QuickBooks fields. Unlike otherCustomField1 and otherCustomField2, which are line item fields, this exists at the transaction level. Hidden by default in the QuickBooks UI.
A globally unique identifier (GUID) you, the developer, can provide for tracking this object in your external system. This field is immutable and can only be set during object creation.
The sales order's linked transactions, such as payments applied, credits used, or associated purchase orders.
IMPORTANT: You must specify the parameter includeLinkedTransactions when fetching a list of sales orders to receive this field because it is not returned by default.
{"docsConfig":{"theme":"mint","$schema":"https://mintlify.com/docs.json","name":"Conductor Docs","colors":{"primary":"#9563FF","light":"#AE87FF","dark":"#0D001D"},"logo":{"light":"https://mintcdn.com/conductor/hjDC6C2Dz4sn63AO/logo/light.png?fit=max\u0026auto=format\u0026n=hjDC6C2Dz4sn63AO\u0026q=85\u0026s=43ebf17eb46ef6256a508d4fac23b3bf","dark":"https://mintcdn.com/conductor/hjDC6C2Dz4sn63AO/logo/dark.png?fit=max\u0026auto=format\u0026n=hjDC6C2Dz4sn63AO\u0026q=85\u0026s=dbd4c90195fb31cbae682dd4bfb98350","href":"https://conductor.is"},"favicon":"https://mintcdn.com/conductor/79gIlu1T1D-ycZhm/favicon.png?fit=max\u0026auto=format\u0026n=79gIlu1T1D-ycZhm\u0026q=85\u0026s=52c2193ef1a37fb3c2a843f148178e26","api":{"openapi":"openapi.documented.yml","playground":{"display":"interactive"}},"background":{"color":{"dark":"#090014"}},"navbar":{"links":[{"href":"mailto:support@conductor.is?subject=Conductor Help","label":"Support"},{"href":"https://dashboard.conductor.is","label":"Dashboard"}],"primary":{"type":"button","label":"Sign up","href":"https://dashboard.conductor.is/sign-up"}},"footer":{"socials":{"twitter":"https://twitter.com/conductor_is","github":"https://github.com/conductor-is","linkedin":"https://linkedin.com/company/conductor-is"},"links":[{"header":"Product","items":[{"label":"Core","href":"https://conductor.is/"},{"label":"FAQ","href":"https://docs.conductor.is/faq"},{"label":"Security","href":"https://docs.conductor.is/security"},{"label":"Testimonials","href":"https://conductor.is/"},{"label":"Pricing","href":"https://conductor.is/"}]},{"header":"Resources","items":[{"label":"Documentation","href":"https://docs.conductor.is"},{"label":"Help Center","href":"https://docs.conductor.is/help"},{"label":"Status","href":"https://status.conductor.is"},{"label":"Quickstart","href":"https://docs.conductor.is/quickstart"}]},{"header":"Company","items":[{"label":"About","href":"https://conductor.is/company"},{"label":"Values","href":"https://conductor-io.notion.site/Conductor-s-Values-83e9eb6e4e4d40a2973b24513dc60f99?pvs=4"},{"label":"Contact","href":"mailto:support@conductor.is?subject=Conductor Help"}]},{"header":"Legal","items":[{"label":"Privacy Policy","href":"https://conductor.is/privacy"},{"label":"Terms of Service","href":"https://conductor.is/terms"},{"label":"Trust Center","href":"https://trust.conductor.is"}]}]},"styling":{"codeblocks":"system","latex":false},"integrations":{"ga4":{"measurementId":"G-X8MDB0LXNF"}},"contextual":{"options":["copy","view","chatgpt","claude"],"display":"header"},"navigation":{"pages":[]}},"deployment":{"deploymentMetadataValue":{"subdomain":"conductor","hasAudioNarration":false,"actualSubdomain":"conductor","customDomains":["docs.conductor.is"],"gitSource":{"type":"github","owner":"conductor-is","repo":"conductor","deployBranch":"main","contentDirectory":"apps/docs","isPrivate":false,"mountPath":"","label":""},"chroma":{"liveDeploymentHistoryId":"6adfe6dab98f79cb919c354c","collectionId":"50333b55-fdc5-45b0-873c-be44a7246f6c","schemaVersion":"v3","latestBuiltDeploymentHistoryId":"6adfe6dab98f79cb919c354c"},"feedback":{"edits":false},"entitlements":{"AI_CHAT":{"status":"ENABLED"},"WEB_MCP":{"status":"ENABLED"},"NARRATION":{"status":"ENABLED"}},"buildId":"6adfe6dab98f79cb919c354c","clientVersion":"0.0.3971","searchFilterCounts":[{"language":"default","tag":"API Reference","count":337},{"language":"default","tag":"Transactions","count":160},{"language":"default","tag":"General","count":104},{"language":"default","tag":"Items","count":53},{"language":"default","tag":"Help","count":25},{"language":"default","tag":"Documentation","count":15},{"language":"default","tag":"Guides","count":14},{"language":"default","tag":"Reports","count":11},{"language":"default","tag":"QuickBooks Desktop API","count":10},{"language":"default","tag":"Connection errors","count":9}]},"assistantConfig":{},"basePath":"","hasChatPermissions":true,"hasWebMcpPermissions":true,"toggles":[{"name":"kill-isr","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"agent-mintlify-slack","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"editor-v7-file-tree","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"agent-integrations-settings","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"automations-pr-grouping","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"custom-prefix","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"analytics-v7","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"user-flows-analytics","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"no-publish-flow","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"workos-onboarding","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"llms-txt-v2","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"pause-universal-search-reconcile","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"snapshot-serving-live","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"stripTemperatureMiddleware","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"per-site-search-delta","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"support-platform-pylon-zendesk","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"snapshot-serving","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"instant-rollback","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"granular-notifications-server","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"granular-notifications","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"editor-private-page-search","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"automations-fable","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"fixed-ai-action-pricing","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"automation-resolve-merge-conflict","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"scoped-publishing","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"mintql","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"page-level-analytics","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"editor-version-history-v2","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"editor-nav-generations","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"billing-page-v2","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"workspace-projects","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"assistant-v5","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"byok-sep-25","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"fork-pr-previews","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"revalidation-jwt","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"vite-origin","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"editor-agent-model-picker","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"billing-updated-9-15","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"workos-sso-scim","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"hobby-abuse-scan","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"dashboard-inbox","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"workos-signup","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"workos-enabled","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false}],"isAtlas":false,"googleFontsInlined":false},"customCss":[],"page":{"pagePath":"api-ref/qbd/sales-orders/update","slug":"/api-ref/qbd/sales-orders/update","pageMetadata":{"openapi":"POST /quickbooks-desktop/sales-orders/{id}","title":"Update a sales order","description":"Updates an existing sales order.\n\n**NOTE:** If you include `lines` or `lineGroups`, QuickBooks Desktop replaces each included line list with the array you send, so include unchanged lines you want to keep and use `id: \"-1\"` for new lines.","href":"/api-ref/qbd/sales-orders/update"},"description":{"compiledSource":"\"use strict\";\nconst {Fragment: _Fragment, jsx: _jsx, jsxs: _jsxs} = arguments[0];\nconst {useMDXComponents: _provideComponents} = arguments[0];\nfunction _createMdxContent(props) {\n const _components = {\n code: \"code\",\n p: \"p\",\n strong: \"strong\",\n ..._provideComponents(),\n ...props.components\n };\n return _jsxs(_Fragment, {\n children: [_jsx(_components.p, {\n children: \"Updates an existing sales order.\"\n }), \"\\n\", _jsxs(_components.p, {\n children: [_jsx(_components.strong, {\n children: \"NOTE:\"\n }), \" If you include \", _jsx(_components.code, {\n children: \"lines\"\n }), \" or \", _jsx(_components.code, {\n children: \"lineGroups\"\n }), \", QuickBooks Desktop replaces each included line list with the array you send, so include unchanged lines you want to keep and use \", _jsx(_components.code, {\n children: \"id: \\\"-1\\\"\"\n }), \" for new lines.\"]\n })]\n });\n}\nfunction MDXContent(props = {}) {\n const {wrapper: MDXLayout} = {\n ..._provideComponents(),\n ...props.components\n };\n return MDXLayout ? _jsx(MDXLayout, {\n ...props,\n children: _jsx(_createMdxContent, {\n ...props\n })\n }) : _createMdxContent(props);\n}\nreturn {\n default: MDXContent\n};\n","frontmatter":{},"scope":{}},"pageType":"default","mdx":{"mdxSource":{"compiledSource":"\"use strict\";const{Fragment:_Fragment,jsx:_jsx}=arguments[0];const{useMDXComponents:_provideComponents}=arguments[0];function _createMdxContent(props){return _jsx(_Fragment,{})}function MDXContent(props={}){const{wrapper:MDXLayout}={..._provideComponents(),...props.components};return MDXLayout?_jsx(MDXLayout,{...props,children:_jsx(_createMdxContent,{...props})}):_createMdxContent(props)}return{default:MDXContent}","frontmatter":{},"scope":{"codeStyling":"system","config":{},"pageMetadata":{"openapi":"POST /quickbooks-desktop/sales-orders/{id}","title":"Update a sales order","description":"Updates an existing sales order.\n\n**NOTE:** If you include `lines` or `lineGroups`, QuickBooks Desktop replaces each included line list with the array you send, so include unchanged lines you want to keep and use `id: \"-1\"` for new lines.","href":"/api-ref/qbd/sales-orders/update"}}},"mdxSourceWithNoJs":null},"mdxExtracts":{"tableOfContents":[],"codeExamples":{}},"jsLinks":[],"openApiReferenceData":{"operation":{"summary":"Update a sales order","description":"Updates an existing sales order.\n\n**NOTE:** If you include `lines` or `lineGroups`, QuickBooks Desktop replaces each included line list with the array you send, so include unchanged lines you want to keep and use `id: \"-1\"` for new lines.","security":["70ae899b-a5cf-42e8-bcf8-d375eec1c4d4"],"parameters":["5acc0c26-9439-40e5-8979-0cfc4ec2d0d3","14c2af08-cd62-4c8a-b523-45b2873c7567"],"requestBody":"b6f0305c-ce8f-4a3b-8ee5-c33672c00099","responses":{"200":"93896fe7-d89d-4bd6-88f6-5fca18f85236"},"x-codeSamples":[{"lang":"JavaScript","source":"import Conductor from 'conductor-node';\n\nconst conductor = new Conductor({\n apiKey: process.env['CONDUCTOR_SECRET_KEY'], // This is the default and can be omitted\n});\n\nconst salesOrder = await conductor.qbd.salesOrders.update('123ABC-1234567890', {\n revisionNumber: '1721172183',\n conductorEndUserId: 'end_usr_1234567abcdefg',\n});\n\nconsole.log(salesOrder.id);"},{"lang":"Python","source":"import os\nfrom conductor import Conductor\n\nconductor = Conductor(\n api_key=os.environ.get(\"CONDUCTOR_SECRET_KEY\"), # This is the default and can be omitted\n)\nsales_order = conductor.qbd.sales_orders.update(\n id=\"123ABC-1234567890\",\n revision_number=\"1721172183\",\n conductor_end_user_id=\"end_usr_1234567abcdefg\",\n)\nprint(sales_order.id)"}],"method":"post","type":"path","servers":["045cea4d-dfb6-46e4-9c51-52452b7b239b"],"path":"/quickbooks-desktop/sales-orders/{id}","baseUrlOptions":["https://api.conductor.is/v1"],"title":"Update a sales order","codeSamples":[{"lang":"JavaScript","source":"import Conductor from 'conductor-node';\n\nconst conductor = new Conductor({\n apiKey: process.env['CONDUCTOR_SECRET_KEY'], // This is the default and can be omitted\n});\n\nconst salesOrder = await conductor.qbd.salesOrders.update('123ABC-1234567890', {\n revisionNumber: '1721172183',\n conductorEndUserId: 'end_usr_1234567abcdefg',\n});\n\nconsole.log(salesOrder.id);"},{"lang":"Python","source":"import os\nfrom conductor import Conductor\n\nconductor = Conductor(\n api_key=os.environ.get(\"CONDUCTOR_SECRET_KEY\"), # This is the default and can be omitted\n)\nsales_order = conductor.qbd.sales_orders.update(\n id=\"123ABC-1234567890\",\n revision_number=\"1721172183\",\n conductor_end_user_id=\"end_usr_1234567abcdefg\",\n)\nprint(sales_order.id)"}],"requiredOnlyExamples":false,"requestExampleType":"codeSamples","responseExampleType":"generated"},"dependencies":{"parameters":{"5acc0c26-9439-40e5-8979-0cfc4ec2d0d3":{"in":"header","name":"Conductor-End-User-Id","schema":{"type":"string","description":"The ID of the End-User to receive this request.","example":"end_usr_1234567abcdefg","x-stainless-naming":{"typescript":{"method_argument":"conductorEndUserId"},"mcp":{"method_argument":"conductorEndUserId"}},"isRequired":true,"uniqueKey":"","typeLabel":"string"},"required":true,"description":"The ID of the End-User to receive this request."},"14c2af08-cd62-4c8a-b523-45b2873c7567":{"in":"path","name":"id","schema":{"type":"string","maxLength":36,"description":"The QuickBooks-assigned unique identifier of the sales order to update.","example":"123ABC-1234567890","isRequired":true,"uniqueKey":"","typeLabel":"string"},"required":true,"description":"The QuickBooks-assigned unique identifier of the sales order to update."}},"requestBody":{"required":true,"content":{"application/json":{"schema":{"type":"object","properties":{"revisionNumber":{"type":"string","description":"The current QuickBooks-assigned revision number of the sales order object you are updating, which you can get by fetching the object first. Provide the most recent `revisionNumber` to ensure you're working with the latest data; otherwise, the update will return an error.","example":"1721172183","isRequired":true,"uniqueKey":"revisionNumber","typeLabel":"string"},"customerId":{"description":"The customer or customer-job associated with this sales order.","example":"80000001-1234567890","type":"string","maxLength":36,"uniqueKey":"customerId","typeLabel":"string"},"classId":{"description":"The sales order's class. Classes can be used to categorize objects into meaningful segments, such as department, location, or type of work. In QuickBooks, class tracking is off by default. A class defined here is automatically used in this sales order's line items unless overridden at the line item level.","example":"80000001-1234567890","type":"string","maxLength":36,"uniqueKey":"classId","typeLabel":"string"},"documentTemplateId":{"description":"The predefined template in QuickBooks that determines the layout and formatting for this sales order when printed or displayed.","example":"80000001-1234567890","type":"string","maxLength":36,"uniqueKey":"documentTemplateId","typeLabel":"string"},"transactionDate":{"type":"string","format":"date","description":"The date of this sales order, in ISO 8601 format (YYYY-MM-DD).","example":"2024-10-01","uniqueKey":"transactionDate","typeLabel":"string\u003cdate>"},"refNumber":{"description":"The case-sensitive user-defined reference number for this sales order, which can be used to identify the transaction in QuickBooks. This value is not required to be unique and can be arbitrarily changed by the QuickBooks user.\n\nMaximum length: 11 characters.","example":"SO-1234","type":"string","maxLength":11,"uniqueKey":"refNumber","typeLabel":"string"},"billingAddress":{"description":"The sales order's billing address.","type":"object","properties":{"line1":{"description":"The first line of the address (e.g., street, PO Box, or company name).\n\nMaximum length: 41 characters.","example":"Conductor Labs Inc.","type":"string","maxLength":41,"uniqueKey":"billingAddress.line1","typeLabel":"string"},"line2":{"description":"The second line of the address, if needed (e.g., apartment, suite, unit, or building).\n\nMaximum length: 41 characters.","example":"540 Market St.","type":"string","maxLength":41,"uniqueKey":"billingAddress.line2","typeLabel":"string"},"line3":{"description":"The third line of the address, if needed.\n\nMaximum length: 41 characters.","example":"Suite 100","type":"string","maxLength":41,"uniqueKey":"billingAddress.line3","typeLabel":"string"},"line4":{"description":"The fourth line of the address, if needed.\n\nMaximum length: 41 characters.","example":"","type":"string","maxLength":41,"uniqueKey":"billingAddress.line4","typeLabel":"string"},"line5":{"description":"The fifth line of the address, if needed.\n\nMaximum length: 41 characters.","example":"","type":"string","maxLength":41,"uniqueKey":"billingAddress.line5","typeLabel":"string"},"city":{"description":"The city, district, suburb, town, or village name of the address.\n\nMaximum length: 31 characters.","example":"San Francisco","type":"string","maxLength":31,"uniqueKey":"billingAddress.city","typeLabel":"string"},"state":{"description":"The state, county, province, or region name of the address.\n\nMaximum length: 21 characters.","example":"CA","type":"string","maxLength":21,"uniqueKey":"billingAddress.state","typeLabel":"string"},"postalCode":{"description":"The postal code or ZIP code of the address.\n\nMaximum length: 13 characters.","example":"94110","type":"string","maxLength":13,"uniqueKey":"billingAddress.postalCode","typeLabel":"string"},"country":{"description":"The country name of the address.\n\nMaximum length: 31 characters.","example":"United States","type":"string","maxLength":31,"uniqueKey":"billingAddress.country","typeLabel":"string"},"note":{"description":"A note written at the bottom of the address in the form in which it appears, such as the invoice form.\n\nMaximum length: 41 characters.","example":"Conductor HQ","type":"string","maxLength":41,"uniqueKey":"billingAddress.note","typeLabel":"string"}},"additionalProperties":false,"uniqueKey":"billingAddress","typeLabel":"object"},"shippingAddress":{"description":"The sales order's shipping address.","type":"object","properties":{"line1":{"description":"The first line of the address (e.g., street, PO Box, or company name).\n\nMaximum length: 41 characters.","example":"Conductor Labs Inc.","type":"string","maxLength":41,"uniqueKey":"shippingAddress.line1","typeLabel":"string"},"line2":{"description":"The second line of the address, if needed (e.g., apartment, suite, unit, or building).\n\nMaximum length: 41 characters.","example":"540 Market St.","type":"string","maxLength":41,"uniqueKey":"shippingAddress.line2","typeLabel":"string"},"line3":{"description":"The third line of the address, if needed.\n\nMaximum length: 41 characters.","example":"Suite 100","type":"string","maxLength":41,"uniqueKey":"shippingAddress.line3","typeLabel":"string"},"line4":{"description":"The fourth line of the address, if needed.\n\nMaximum length: 41 characters.","example":"","type":"string","maxLength":41,"uniqueKey":"shippingAddress.line4","typeLabel":"string"},"line5":{"description":"The fifth line of the address, if needed.\n\nMaximum length: 41 characters.","example":"","type":"string","maxLength":41,"uniqueKey":"shippingAddress.line5","typeLabel":"string"},"city":{"description":"The city, district, suburb, town, or village name of the address.\n\nMaximum length: 31 characters.","example":"San Francisco","type":"string","maxLength":31,"uniqueKey":"shippingAddress.city","typeLabel":"string"},"state":{"description":"The state, county, province, or region name of the address.\n\nMaximum length: 21 characters.","example":"CA","type":"string","maxLength":21,"uniqueKey":"shippingAddress.state","typeLabel":"string"},"postalCode":{"description":"The postal code or ZIP code of the address.\n\nMaximum length: 13 characters.","example":"94110","type":"string","maxLength":13,"uniqueKey":"shippingAddress.postalCode","typeLabel":"string"},"country":{"description":"The country name of the address.\n\nMaximum length: 31 characters.","example":"United States","type":"string","maxLength":31,"uniqueKey":"shippingAddress.country","typeLabel":"string"},"note":{"description":"A note written at the bottom of the address in the form in which it appears, such as the invoice form.\n\nMaximum length: 41 characters.","example":"Conductor HQ","type":"string","maxLength":41,"uniqueKey":"shippingAddress.note","typeLabel":"string"}},"additionalProperties":false,"uniqueKey":"shippingAddress","typeLabel":"object"},"purchaseOrderNumber":{"description":"The customer's Purchase Order (PO) number associated with this sales order. This field is often used to cross-reference the sales order with the customer's purchasing system.\n\nMaximum length: 25 characters.","example":"PO-1234","type":"string","maxLength":25,"uniqueKey":"purchaseOrderNumber","typeLabel":"string"},"termsId":{"description":"The sales order's payment terms, defining when payment is due and any applicable discounts.","example":"80000001-1234567890","type":"string","maxLength":36,"uniqueKey":"termsId","typeLabel":"string"},"dueDate":{"description":"The date by which this sales order must be paid, in ISO 8601 format (YYYY-MM-DD).","example":"2024-10-31","type":"string","format":"date","uniqueKey":"dueDate","typeLabel":"string\u003cdate>"},"salesRepresentativeId":{"description":"The sales order's sales representative. Sales representatives can be employees, vendors, or other names in QuickBooks.","example":"80000001-1234567890","type":"string","maxLength":36,"uniqueKey":"salesRepresentativeId","typeLabel":"string"},"shipmentOrigin":{"description":"The origin location from where the product associated with this sales order is shipped. This is the point at which ownership and liability for goods transfer from seller to buyer. Internally, QuickBooks uses the term \"FOB\" for this field, which stands for \"freight on board\". This field is informational and has no accounting implications.\n\nMaximum length: 13 characters.","example":"San Francisco, CA","type":"string","maxLength":13,"uniqueKey":"shipmentOrigin","typeLabel":"string"},"shippingDate":{"description":"The date when the products or services for this sales order were shipped or are expected to be shipped, in ISO 8601 format (YYYY-MM-DD).","example":"2024-10-01","type":"string","format":"date","uniqueKey":"shippingDate","typeLabel":"string\u003cdate>"},"shippingMethodId":{"description":"The shipping method used for this sales order, such as standard mail or overnight delivery.","example":"80000001-1234567890","type":"string","maxLength":36,"uniqueKey":"shippingMethodId","typeLabel":"string"},"salesTaxItemId":{"description":"The sales-tax item used to calculate the actual tax amount for this sales order's transactions by applying a specific tax rate collected for a single tax agency. Unlike `salesTaxCode`, which only indicates general taxability, this field drives the actual tax calculation and reporting.","example":"80000001-1234567890","type":"string","maxLength":36,"uniqueKey":"salesTaxItemId","typeLabel":"string"},"isManuallyClosed":{"type":"boolean","description":"Indicates whether this sales order has been manually marked as closed, even if it has not been invoiced.","example":true,"uniqueKey":"isManuallyClosed","typeLabel":"boolean"},"memo":{"description":"A memo or note for this sales order.\n\nMaximum length: 4095 characters.","example":"Customer requested rush delivery","type":"string","maxLength":4095,"uniqueKey":"memo","typeLabel":"string"},"customerMessageId":{"description":"The message to display to the customer on the sales order.","example":"80000001-1234567890","type":"string","maxLength":36,"uniqueKey":"customerMessageId","typeLabel":"string"},"isQueuedForPrint":{"type":"boolean","description":"Indicates whether this sales order is included in the queue of documents for QuickBooks to print.","example":true,"uniqueKey":"isQueuedForPrint","typeLabel":"boolean"},"isQueuedForEmail":{"description":"Indicates whether this sales order is included in the queue of documents for QuickBooks to email to the customer.","example":true,"type":"boolean","uniqueKey":"isQueuedForEmail","typeLabel":"boolean"},"salesTaxCodeId":{"description":"The sales-tax code for this sales order, determining whether it is taxable or non-taxable. This can be overridden at the transaction-line level.\n\nDefault codes include \"Non\" (non-taxable) and \"Tax\" (taxable), but custom codes can also be created in QuickBooks Desktop. If QuickBooks Desktop is not set up to charge sales tax (via the \"Do You Charge Sales Tax?\" preference), it assigns the default non-taxable sales-tax code configured in the company file to all sales.","example":"80000001-1234567890","type":"string","maxLength":36,"uniqueKey":"salesTaxCodeId","typeLabel":"string"},"otherCustomField":{"description":"A built-in custom field for additional information specific to this sales order. Unlike the user-defined fields in the `customFields` array, this is a standard QuickBooks field that exists for all sales orders for convenience. Developers often use this field for tracking information that doesn't fit into other standard QuickBooks fields. Unlike `otherCustomField1` and `otherCustomField2`, which are line item fields, this exists at the transaction level. Hidden by default in the QuickBooks UI.\n\nMaximum length: 29 characters.","example":"Special handling required","type":"string","maxLength":29,"uniqueKey":"otherCustomField","typeLabel":"string"},"exchangeRate":{"description":"The market exchange rate between this sales order's currency and the home currency in QuickBooks at the time of this transaction. Represented as a decimal value (e.g., 1.2345 for 1 EUR = 1.2345 USD if USD is the home currency).","example":1.2345,"type":"number","uniqueKey":"exchangeRate","typeLabel":"number"},"lines":{"description":"The sales order's line items, each representing a single product or service ordered.\n\n**IMPORTANT**:\n\n1. Including this array in your update request will **REPLACE** all existing line items for the sales order with this array. To keep any existing line items, you must include them in this array even if they have not changed. **Any line items not included will be removed.**\n\n2. To add a new line item, include it here with the `id` field set to `-1`.\n\n3. If you do not wish to modify any line items, omit this field entirely to keep them unchanged.","minItems":1,"type":"array","items":{"type":"object","properties":{"id":{"type":"string","maxLength":36,"description":"The QuickBooks-assigned unique identifier of an existing sales order line you wish to retain or update.\n\n**IMPORTANT**: Set this field to `-1` for new sales order lines you wish to add.","example":"456DEF-1234567890","isRequired":true,"uniqueKey":"lines.items.[INDEX].id","typeLabel":"string"},"itemId":{"description":"The item associated with this sales order line. This can refer to any good or service that the business buys or sells, including item types such as a service item, inventory item, or special calculation item like a discount item or sales-tax item.","example":"80000001-1234567890","type":"string","maxLength":36,"uniqueKey":"lines.items.[INDEX].itemId","typeLabel":"string"},"description":{"description":"A description of this sales order line.\n\nMaximum length: 4095 characters.","example":"Widget Model X100 - Blue","type":"string","maxLength":4095,"uniqueKey":"lines.items.[INDEX].description","typeLabel":"string"},"quantity":{"description":"The quantity of the item associated with this sales order line. This field cannot be cleared.\n\n**NOTE**: Do not use this field if the associated item is a discount item.","example":5,"type":"number","uniqueKey":"lines.items.[INDEX].quantity","typeLabel":"number"},"unitOfMeasure":{"description":"The unit-of-measure used for the `quantity` in this sales order line. Must be a valid unit within the item's available units of measure.\n\nMaximum length: 31 characters.","example":"Each","type":"string","maxLength":31,"uniqueKey":"lines.items.[INDEX].unitOfMeasure","typeLabel":"string"},"overrideUnitOfMeasureSetId":{"description":"Specifies an alternative unit-of-measure set when updating this sales order line's `unitOfMeasure` field (e.g., \"pound\" or \"kilogram\"). This allows you to select units from a different set than the item's default unit-of-measure set, which remains unchanged on the item itself. The override applies only to this specific line. For example, you can sell an item typically measured in volume units using weight units in a specific transaction by specifying a different unit-of-measure set with this field.\n\nIMPORTANT: Right after QuickBooks Desktop launches, it can briefly report an alternate `id` for a unit-of-measure set, so match on `fullName` when joining to the unit-of-measure sets list.","example":"80000001-1234567890","type":"string","maxLength":36,"uniqueKey":"lines.items.[INDEX].overrideUnitOfMeasureSetId","typeLabel":"string"},"rate":{"description":"The price per unit for this sales order line. If both `rate` and `amount` are specified, `rate` will be ignored. If both `quantity` and `amount` are specified but not `rate`, QuickBooks will use them to calculate `rate`. Represented as a decimal string. This field cannot be cleared.\n\nDecimal string format: up to 5 decimal places and up to 10 digits before the decimal point (for example, \"123.45\").","example":"10.00","type":"string","uniqueKey":"lines.items.[INDEX].rate","typeLabel":"string"},"ratePercent":{"description":"The price of this sales order line expressed as a percentage. Typically used for discount or markup items.","example":"10.5","type":"string","uniqueKey":"lines.items.[INDEX].ratePercent","typeLabel":"string"},"priceLevelId":{"description":"The price level applied to this sales order line. This overrides any price level set on the corresponding customer. The resulting sales order line will not show this price level, only the final `rate` calculated from it.","example":"80000001-1234567890","type":"string","maxLength":36,"uniqueKey":"lines.items.[INDEX].priceLevelId","typeLabel":"string"},"classId":{"description":"The sales order line's class. Classes can be used to categorize objects into meaningful segments, such as department, location, or type of work. In QuickBooks, class tracking is off by default. If a class is specified for the entire parent transaction, it is automatically applied to all sales order lines unless overridden here, at the transaction line level.","example":"80000001-1234567890","type":"string","maxLength":36,"uniqueKey":"lines.items.[INDEX].classId","typeLabel":"string"},"amount":{"description":"The monetary amount of this sales order line, represented as a decimal string. If both `quantity` and `rate` are specified but not `amount`, QuickBooks will use them to calculate `amount`. If `amount`, `rate`, and `quantity` are all unspecified, then QuickBooks will calculate `amount` based on a `quantity` of `1` and the suggested `rate`. This field cannot be cleared.\n\nDecimal string format: exactly 2 decimal places when cents are included and up to 13 digits before the decimal point (for example, \"123.45\").","example":"1000.00","type":"string","uniqueKey":"lines.items.[INDEX].amount","typeLabel":"string"},"priceRuleConflictStrategy":{"description":"Specifies how to resolve price rule conflicts when adding or modifying this sales order line.","example":"base_price","type":"string","enum":["base_price","zero"],"uniqueKey":"lines.items.[INDEX].priceRuleConflictStrategy","typeLabel":"enum\u003cstring>"},"inventorySiteId":{"description":"The site location where inventory for the item associated with this sales order line is stored.","example":"80000001-1234567890","type":"string","maxLength":36,"uniqueKey":"lines.items.[INDEX].inventorySiteId","typeLabel":"string"},"inventorySiteLocationId":{"description":"The specific location (e.g., bin or shelf) within the inventory site where the item associated with this sales order line is stored.","example":"80000001-1234567890","type":"string","maxLength":36,"uniqueKey":"lines.items.[INDEX].inventorySiteLocationId","typeLabel":"string"},"serialNumber":{"description":"The serial number of the item associated with this sales order line. This is used for tracking individual units of serialized inventory items.\n\nMaximum length: 4095 characters.","example":"SN1234567890","type":"string","maxLength":4095,"uniqueKey":"lines.items.[INDEX].serialNumber","typeLabel":"string"},"lotNumber":{"description":"The lot number of the item associated with this sales order line. Used for tracking groups of inventory items that are purchased or manufactured together.\n\nMaximum length: 40 characters.","example":"LOT2023-001","type":"string","maxLength":40,"uniqueKey":"lines.items.[INDEX].lotNumber","typeLabel":"string"},"salesTaxCodeId":{"description":"The sales-tax code for this sales order line, determining whether it is taxable or non-taxable. If set, this overrides any sales-tax codes defined on the parent transaction or the associated item.\n\nDefault codes include \"Non\" (non-taxable) and \"Tax\" (taxable), but custom codes can also be created in QuickBooks Desktop. If QuickBooks Desktop is not set up to charge sales tax (via the \"Do You Charge Sales Tax?\" preference), it assigns the default non-taxable sales-tax code configured in the company file to all sales.","example":"80000001-1234567890","type":"string","maxLength":36,"uniqueKey":"lines.items.[INDEX].salesTaxCodeId","typeLabel":"string"},"isManuallyClosed":{"type":"boolean","description":"Indicates whether this sales order line has been manually marked as closed, even if it has not been invoiced.","example":true,"uniqueKey":"lines.items.[INDEX].isManuallyClosed","typeLabel":"boolean"},"otherCustomField1":{"description":"A built-in custom field for additional information specific to this sales order line. Unlike the user-defined fields in the `customFields` array, this is a standard QuickBooks field that exists for all sales order lines for convenience. Developers often use this field for tracking information that doesn't fit into other standard QuickBooks fields. Hidden by default in the QuickBooks UI.\n\nMaximum length: 29 characters.","example":"Special handling required","type":"string","maxLength":29,"uniqueKey":"lines.items.[INDEX].otherCustomField1","typeLabel":"string"},"otherCustomField2":{"description":"A second built-in custom field for additional information specific to this sales order line. Unlike the user-defined fields in the `customFields` array, this is a standard QuickBooks field that exists for all sales order lines for convenience. Like `otherCustomField1`, developers often use this field for tracking information that doesn't fit into other standard QuickBooks fields. Hidden by default in the QuickBooks UI.\n\nMaximum length: 29 characters.","example":"Always ship with a spare","type":"string","maxLength":29,"uniqueKey":"lines.items.[INDEX].otherCustomField2","typeLabel":"string"}},"required":["id"],"additionalProperties":false,"uniqueKey":"lines.items.[INDEX]","typeLabel":"object"},"uniqueKey":"lines","typeLabel":"object[]"},"lineGroups":{"description":"The sales order's line item groups, each representing a predefined set of related items.\n\n**IMPORTANT**:\n\n1. Including this array in your update request will **REPLACE** all existing line item groups for the sales order with this array. To keep any existing line item groups, you must include them in this array even if they have not changed. **Any line item groups not included will be removed.**\n\n2. To add a new line item group, include it here with the `id` field set to `-1`.\n\n3. If you do not wish to modify any line item groups, omit this field entirely to keep them unchanged.","minItems":1,"type":"array","items":{"type":"object","properties":{"id":{"type":"string","maxLength":36,"description":"The QuickBooks-assigned unique identifier of an existing sales order line group you wish to retain or update.\n\n**IMPORTANT**: Set this field to `-1` for new sales order line groups you wish to add.","example":"456DEF-1234567890","isRequired":true,"uniqueKey":"lineGroups.items.[INDEX].id","typeLabel":"string"},"itemGroupId":{"description":"The sales order line group's item group, representing a predefined set of items bundled because they are commonly purchased together or grouped for faster entry.","example":"80000001-1234567890","type":"string","maxLength":36,"uniqueKey":"lineGroups.items.[INDEX].itemGroupId","typeLabel":"string"},"quantity":{"description":"The quantity of the item group associated with this sales order line group. This field cannot be cleared.\n\n**NOTE**: Do not use this field if the associated item group is a discount item group.","example":5,"type":"number","uniqueKey":"lineGroups.items.[INDEX].quantity","typeLabel":"number"},"unitOfMeasure":{"description":"The unit-of-measure used for the `quantity` in this sales order line group. Must be a valid unit within the item's available units of measure.\n\nMaximum length: 31 characters.","example":"Each","type":"string","maxLength":31,"uniqueKey":"lineGroups.items.[INDEX].unitOfMeasure","typeLabel":"string"},"overrideUnitOfMeasureSetId":{"description":"Specifies an alternative unit-of-measure set when updating this sales order line group's `unitOfMeasure` field (e.g., \"pound\" or \"kilogram\"). This allows you to select units from a different set than the item's default unit-of-measure set, which remains unchanged on the item itself. The override applies only to this specific line. For example, you can sell an item typically measured in volume units using weight units in a specific transaction by specifying a different unit-of-measure set with this field.\n\nIMPORTANT: Right after QuickBooks Desktop launches, it can briefly report an alternate `id` for a unit-of-measure set, so match on `fullName` when joining to the unit-of-measure sets list.","example":"80000001-1234567890","type":"string","maxLength":36,"uniqueKey":"lineGroups.items.[INDEX].overrideUnitOfMeasureSetId","typeLabel":"string"},"lines":{"description":"The sales order line group's line items, each representing a single product or service ordered.\n\n**IMPORTANT**:\n\n1. Including this array in your update request will **REPLACE** all existing line items for the sales order line group with this array. To keep any existing line items, you must include them in this array even if they have not changed. **Any line items not included will be removed.**\n\n2. To add a new line item, include it here with the `id` field set to `-1`.\n\n3. If you do not wish to modify any line items, omit this field entirely to keep them unchanged.","minItems":1,"type":"array","items":{"type":"object","properties":{"id":{"type":"string","maxLength":36,"description":"The QuickBooks-assigned unique identifier of an existing sales order line you wish to retain or update.\n\n**IMPORTANT**: Set this field to `-1` for new sales order lines you wish to add.","example":"456DEF-1234567890","isRequired":true,"uniqueKey":"lineGroups.items.[INDEX].lines.items.[INDEX].id","typeLabel":"string"},"itemId":{"description":"The item associated with this sales order line. This can refer to any good or service that the business buys or sells, including item types such as a service item, inventory item, or special calculation item like a discount item or sales-tax item.","example":"80000001-1234567890","type":"string","maxLength":36,"uniqueKey":"lineGroups.items.[INDEX].lines.items.[INDEX].itemId","typeLabel":"string"},"description":{"description":"A description of this sales order line.\n\nMaximum length: 4095 characters.","example":"Widget Model X100 - Blue","type":"string","maxLength":4095,"uniqueKey":"lineGroups.items.[INDEX].lines.items.[INDEX].description","typeLabel":"string"},"quantity":{"description":"The quantity of the item associated with this sales order line. This field cannot be cleared.\n\n**NOTE**: Do not use this field if the associated item is a discount item.","example":5,"type":"number","uniqueKey":"lineGroups.items.[INDEX].lines.items.[INDEX].quantity","typeLabel":"number"},"unitOfMeasure":{"description":"The unit-of-measure used for the `quantity` in this sales order line. Must be a valid unit within the item's available units of measure.\n\nMaximum length: 31 characters.","example":"Each","type":"string","maxLength":31,"uniqueKey":"lineGroups.items.[INDEX].lines.items.[INDEX].unitOfMeasure","typeLabel":"string"},"overrideUnitOfMeasureSetId":{"description":"Specifies an alternative unit-of-measure set when updating this sales order line's `unitOfMeasure` field (e.g., \"pound\" or \"kilogram\"). This allows you to select units from a different set than the item's default unit-of-measure set, which remains unchanged on the item itself. The override applies only to this specific line. For example, you can sell an item typically measured in volume units using weight units in a specific transaction by specifying a different unit-of-measure set with this field.\n\nIMPORTANT: Right after QuickBooks Desktop launches, it can briefly report an alternate `id` for a unit-of-measure set, so match on `fullName` when joining to the unit-of-measure sets list.","example":"80000001-1234567890","type":"string","maxLength":36,"uniqueKey":"lineGroups.items.[INDEX].lines.items.[INDEX].overrideUnitOfMeasureSetId","typeLabel":"string"},"rate":{"description":"The price per unit for this sales order line. If both `rate` and `amount` are specified, `rate` will be ignored. If both `quantity` and `amount` are specified but not `rate`, QuickBooks will use them to calculate `rate`. Represented as a decimal string. This field cannot be cleared.\n\nDecimal string format: up to 5 decimal places and up to 10 digits before the decimal point (for example, \"123.45\").","example":"10.00","type":"string","uniqueKey":"lineGroups.items.[INDEX].lines.items.[INDEX].rate","typeLabel":"string"},"ratePercent":{"description":"The price of this sales order line expressed as a percentage. Typically used for discount or markup items.","example":"10.5","type":"string","uniqueKey":"lineGroups.items.[INDEX].lines.items.[INDEX].ratePercent","typeLabel":"string"},"priceLevelId":{"description":"The price level applied to this sales order line. This overrides any price level set on the corresponding customer. The resulting sales order line will not show this price level, only the final `rate` calculated from it.","example":"80000001-1234567890","type":"string","maxLength":36,"uniqueKey":"lineGroups.items.[INDEX].lines.items.[INDEX].priceLevelId","typeLabel":"string"},"classId":{"description":"The sales order line's class. Classes can be used to categorize objects into meaningful segments, such as department, location, or type of work. In QuickBooks, class tracking is off by default. If a class is specified for the entire parent transaction, it is automatically applied to all sales order lines unless overridden here, at the transaction line level.","example":"80000001-1234567890","type":"string","maxLength":36,"uniqueKey":"lineGroups.items.[INDEX].lines.items.[INDEX].classId","typeLabel":"string"},"amount":{"description":"The monetary amount of this sales order line, represented as a decimal string. If both `quantity` and `rate` are specified but not `amount`, QuickBooks will use them to calculate `amount`. If `amount`, `rate`, and `quantity` are all unspecified, then QuickBooks will calculate `amount` based on a `quantity` of `1` and the suggested `rate`. This field cannot be cleared.\n\nDecimal string format: exactly 2 decimal places when cents are included and up to 13 digits before the decimal point (for example, \"123.45\").","example":"1000.00","type":"string","uniqueKey":"lineGroups.items.[INDEX].lines.items.[INDEX].amount","typeLabel":"string"},"priceRuleConflictStrategy":{"description":"Specifies how to resolve price rule conflicts when adding or modifying this sales order line.","example":"base_price","type":"string","enum":["base_price","zero"],"uniqueKey":"lineGroups.items.[INDEX].lines.items.[INDEX].priceRuleConflictStrategy","typeLabel":"enum\u003cstring>"},"inventorySiteId":{"description":"The site location where inventory for the item associated with this sales order line is stored.","example":"80000001-1234567890","type":"string","maxLength":36,"uniqueKey":"lineGroups.items.[INDEX].lines.items.[INDEX].inventorySiteId","typeLabel":"string"},"inventorySiteLocationId":{"description":"The specific location (e.g., bin or shelf) within the inventory site where the item associated with this sales order line is stored.","example":"80000001-1234567890","type":"string","maxLength":36,"uniqueKey":"lineGroups.items.[INDEX].lines.items.[INDEX].inventorySiteLocationId","typeLabel":"string"},"serialNumber":{"description":"The serial number of the item associated with this sales order line. This is used for tracking individual units of serialized inventory items.\n\nMaximum length: 4095 characters.","example":"SN1234567890","type":"string","maxLength":4095,"uniqueKey":"lineGroups.items.[INDEX].lines.items.[INDEX].serialNumber","typeLabel":"string"},"lotNumber":{"description":"The lot number of the item associated with this sales order line. Used for tracking groups of inventory items that are purchased or manufactured together.\n\nMaximum length: 40 characters.","example":"LOT2023-001","type":"string","maxLength":40,"uniqueKey":"lineGroups.items.[INDEX].lines.items.[INDEX].lotNumber","typeLabel":"string"},"salesTaxCodeId":{"description":"The sales-tax code for this sales order line, determining whether it is taxable or non-taxable. If set, this overrides any sales-tax codes defined on the parent transaction or the associated item.\n\nDefault codes include \"Non\" (non-taxable) and \"Tax\" (taxable), but custom codes can also be created in QuickBooks Desktop. If QuickBooks Desktop is not set up to charge sales tax (via the \"Do You Charge Sales Tax?\" preference), it assigns the default non-taxable sales-tax code configured in the company file to all sales.","example":"80000001-1234567890","type":"string","maxLength":36,"uniqueKey":"lineGroups.items.[INDEX].lines.items.[INDEX].salesTaxCodeId","typeLabel":"string"},"isManuallyClosed":{"type":"boolean","description":"Indicates whether this sales order line has been manually marked as closed, even if it has not been invoiced.","example":true,"uniqueKey":"lineGroups.items.[INDEX].lines.items.[INDEX].isManuallyClosed","typeLabel":"boolean"},"otherCustomField1":{"description":"A built-in custom field for additional information specific to this sales order line. Unlike the user-defined fields in the `customFields` array, this is a standard QuickBooks field that exists for all sales order lines for convenience. Developers often use this field for tracking information that doesn't fit into other standard QuickBooks fields. Hidden by default in the QuickBooks UI.\n\nMaximum length: 29 characters.","example":"Special handling required","type":"string","maxLength":29,"uniqueKey":"lineGroups.items.[INDEX].lines.items.[INDEX].otherCustomField1","typeLabel":"string"},"otherCustomField2":{"description":"A second built-in custom field for additional information specific to this sales order line. Unlike the user-defined fields in the `customFields` array, this is a standard QuickBooks field that exists for all sales order lines for convenience. Like `otherCustomField1`, developers often use this field for tracking information that doesn't fit into other standard QuickBooks fields. Hidden by default in the QuickBooks UI.\n\nMaximum length: 29 characters.","example":"Always ship with a spare","type":"string","maxLength":29,"uniqueKey":"lineGroups.items.[INDEX].lines.items.[INDEX].otherCustomField2","typeLabel":"string"}},"required":["id"],"additionalProperties":false,"uniqueKey":"lineGroups.items.[INDEX].lines.items.[INDEX]","typeLabel":"object"},"uniqueKey":"lineGroups.items.[INDEX].lines","typeLabel":"object[]"}},"required":["id"],"additionalProperties":false,"uniqueKey":"lineGroups.items.[INDEX]","typeLabel":"object"},"uniqueKey":"lineGroups","typeLabel":"object[]"},"salesChannelName":{"description":"The type of the sales channel for this sales order.","example":"ecommerce","type":"string","enum":["blank","ecommerce"],"uniqueKey":"salesChannelName","typeLabel":"enum\u003cstring>"},"salesStoreName":{"description":"The name of the sales store for this sales order.","example":"Store 1","type":"string","uniqueKey":"salesStoreName","typeLabel":"string"},"salesStoreType":{"description":"The type of the sales store for this sales order.","example":"Retail","type":"string","uniqueKey":"salesStoreType","typeLabel":"string"}},"required":["revisionNumber"],"additionalProperties":false,"uniqueKey":"","typeLabel":"object"},"examples":{"Example":{"title":"Example","value":{"revisionNumber":"1721172183","customerId":"80000001-1234567890","classId":"80000001-1234567890","documentTemplateId":"80000001-1234567890","transactionDate":"2024-10-01","refNumber":"SO-1234","billingAddress":{"line1":"Conductor Labs Inc.","line2":"540 Market St.","line3":"Suite 100","line4":"","line5":"","city":"San Francisco","state":"CA","postalCode":"94110","country":"United States","note":"Conductor HQ"},"shippingAddress":{"line1":"Conductor Labs Inc.","line2":"540 Market St.","line3":"Suite 100","line4":"","line5":"","city":"San Francisco","state":"CA","postalCode":"94110","country":"United States","note":"Conductor HQ"},"purchaseOrderNumber":"PO-1234","termsId":"80000001-1234567890","dueDate":"2024-10-31","salesRepresentativeId":"80000001-1234567890","shipmentOrigin":"San Francisco, CA","shippingDate":"2024-10-01","shippingMethodId":"80000001-1234567890","salesTaxItemId":"80000001-1234567890","isManuallyClosed":true,"memo":"Customer requested rush delivery","customerMessageId":"80000001-1234567890","isQueuedForPrint":true,"isQueuedForEmail":true,"salesTaxCodeId":"80000001-1234567890","otherCustomField":"Special handling required","exchangeRate":1.2345,"lines":[{"id":"456DEF-1234567890","itemId":"80000001-1234567890","description":"Widget Model X100 - Blue","quantity":5,"unitOfMeasure":"Each","overrideUnitOfMeasureSetId":"80000001-1234567890","rate":"10.00","ratePercent":"10.5","priceLevelId":"80000001-1234567890","classId":"80000001-1234567890","amount":"1000.00","priceRuleConflictStrategy":"base_price","inventorySiteId":"80000001-1234567890","inventorySiteLocationId":"80000001-1234567890","serialNumber":"SN1234567890","lotNumber":"LOT2023-001","salesTaxCodeId":"80000001-1234567890","isManuallyClosed":true,"otherCustomField1":"Special handling required","otherCustomField2":"Always ship with a spare"}],"lineGroups":[{"id":"456DEF-1234567890","itemGroupId":"80000001-1234567890","quantity":5,"unitOfMeasure":"Each","overrideUnitOfMeasureSetId":"80000001-1234567890","lines":[{"id":"456DEF-1234567890","itemId":"80000001-1234567890","description":"Widget Model X100 - Blue","quantity":5,"unitOfMeasure":"Each","overrideUnitOfMeasureSetId":"80000001-1234567890","rate":"10.00","ratePercent":"10.5","priceLevelId":"80000001-1234567890","classId":"80000001-1234567890","amount":"1000.00","priceRuleConflictStrategy":"base_price","inventorySiteId":"80000001-1234567890","inventorySiteLocationId":"80000001-1234567890","serialNumber":"SN1234567890","lotNumber":"LOT2023-001","salesTaxCodeId":"80000001-1234567890","isManuallyClosed":true,"otherCustomField1":"Special handling required","otherCustomField2":"Always ship with a spare"}]}],"salesChannelName":"ecommerce","salesStoreName":"Store 1","salesStoreType":"Retail"}}},"exampleType":"generated"}},"exampleType":"generated"},"responses":{"93896fe7-d89d-4bd6-88f6-5fca18f85236":{"description":"Returns the updated sales order.","headers":{"Conductor-Request-Id":{"required":true,"description":"The unique identifier for this API request.","schema":{"type":"string","description":"The unique identifier for this API request.","example":"req_1234567abcdefg"}}},"content":{"application/json":{"schema":{"type":"object","properties":{"id":{"type":"string","description":"The unique identifier assigned by QuickBooks to this sales order. This ID is unique across all transaction types.","example":"123ABC-1234567890","isRequired":true,"uniqueKey":"id","typeLabel":"string"},"objectType":{"description":"The type of object. This value is always `\"qbd_sales_order\"`.","example":"qbd_sales_order","type":"string","const":"qbd_sales_order","isRequired":true,"uniqueKey":"objectType","typeLabel":"string"},"createdAt":{"type":"string","description":"The date and time when this sales order was created, in ISO 8601 format (YYYY-MM-DDThh:mm:ss±hh:mm), which QuickBooks Desktop interprets in the local timezone of the end-user's computer.","example":"2025-01-01T12:34:56.000Z","isRequired":true,"uniqueKey":"createdAt","typeLabel":"string"},"updatedAt":{"type":"string","description":"The date and time when this sales order was last updated, in ISO 8601 format (YYYY-MM-DDThh:mm:ss±hh:mm), which QuickBooks Desktop interprets in the local timezone of the end-user's computer.","example":"2025-02-01T12:34:56.000Z","isRequired":true,"uniqueKey":"updatedAt","typeLabel":"string"},"revisionNumber":{"type":"string","description":"The current QuickBooks-assigned revision number of this sales order object, which changes each time the object is modified. When updating this object, you must provide the most recent `revisionNumber` to ensure you're working with the latest data; otherwise, the update will return an error.","example":"1721172183","isRequired":true,"uniqueKey":"revisionNumber","typeLabel":"string"},"customer":{"oneOf":[{"type":"object","description":"The customer or customer-job associated with this sales order.","required":["id","fullName"],"example":{"id":"80000001-1234567890","fullName":"Acme Corporation"},"properties":{"id":{"oneOf":[{"type":"string","description":"The unique identifier assigned by QuickBooks to this object. This ID is unique across all objects of the same type, but not across different QuickBooks object types.","example":"80000001-1234567890","isRequired":true,"uniqueKey":"customer.oneOf.0.id.oneOf.0","typeLabel":"string"},{"type":"null","description":"The unique identifier assigned by QuickBooks to this object. This ID is unique across all objects of the same type, but not across different QuickBooks object types.","example":"80000001-1234567890","isRequired":true,"uniqueKey":"customer.oneOf.0.id.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"customer.oneOf.0.id","typeLabel":"string | null"},"fullName":{"oneOf":[{"type":"string","description":"The fully-qualified unique name for this object, formed by combining the names of its parent objects with its own `name`, separated by colons. Not case-sensitive.","example":"Parent:Child:Grandchild","isRequired":true,"uniqueKey":"customer.oneOf.0.fullName.oneOf.0","typeLabel":"string"},{"type":"null","description":"The fully-qualified unique name for this object, formed by combining the names of its parent objects with its own `name`, separated by colons. Not case-sensitive.","example":"Parent:Child:Grandchild","isRequired":true,"uniqueKey":"customer.oneOf.0.fullName.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"customer.oneOf.0.fullName","typeLabel":"string | null"}},"additionalProperties":false,"isRequired":true,"uniqueKey":"customer.oneOf.0","typeLabel":"object"},{"type":"null","description":"The customer or customer-job associated with this sales order.","example":{"id":"80000001-1234567890","fullName":"Acme Corporation"},"isRequired":true,"uniqueKey":"customer.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"customer","typeLabel":"object | null"},"class":{"oneOf":[{"type":"object","description":"The sales order's class. Classes can be used to categorize objects into meaningful segments, such as department, location, or type of work. In QuickBooks, class tracking is off by default. A class defined here is automatically used in this sales order's line items unless overridden at the line item level.","required":["id","fullName"],"example":{"id":"80000001-1234567890","fullName":"Online Sales"},"properties":{"id":{"oneOf":[{"type":"string","description":"The unique identifier assigned by QuickBooks to this object. This ID is unique across all objects of the same type, but not across different QuickBooks object types.","example":"80000001-1234567890","isRequired":true,"uniqueKey":"class.oneOf.0.id.oneOf.0","typeLabel":"string"},{"type":"null","description":"The unique identifier assigned by QuickBooks to this object. This ID is unique across all objects of the same type, but not across different QuickBooks object types.","example":"80000001-1234567890","isRequired":true,"uniqueKey":"class.oneOf.0.id.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"class.oneOf.0.id","typeLabel":"string | null"},"fullName":{"oneOf":[{"type":"string","description":"The fully-qualified unique name for this object, formed by combining the names of its parent objects with its own `name`, separated by colons. Not case-sensitive.","example":"Parent:Child:Grandchild","isRequired":true,"uniqueKey":"class.oneOf.0.fullName.oneOf.0","typeLabel":"string"},{"type":"null","description":"The fully-qualified unique name for this object, formed by combining the names of its parent objects with its own `name`, separated by colons. Not case-sensitive.","example":"Parent:Child:Grandchild","isRequired":true,"uniqueKey":"class.oneOf.0.fullName.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"class.oneOf.0.fullName","typeLabel":"string | null"}},"additionalProperties":false,"isRequired":true,"uniqueKey":"class.oneOf.0","typeLabel":"object"},{"type":"null","description":"The sales order's class. Classes can be used to categorize objects into meaningful segments, such as department, location, or type of work. In QuickBooks, class tracking is off by default. A class defined here is automatically used in this sales order's line items unless overridden at the line item level.","example":{"id":"80000001-1234567890","fullName":"Online Sales"},"isRequired":true,"uniqueKey":"class.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"class","typeLabel":"object | null"},"documentTemplate":{"oneOf":[{"type":"object","description":"The predefined template in QuickBooks that determines the layout and formatting for this sales order when printed or displayed.","required":["id","fullName"],"example":{"id":"80000001-1234567890","fullName":"Sales Order Template"},"properties":{"id":{"oneOf":[{"type":"string","description":"The unique identifier assigned by QuickBooks to this object. This ID is unique across all objects of the same type, but not across different QuickBooks object types.","example":"80000001-1234567890","isRequired":true,"uniqueKey":"documentTemplate.oneOf.0.id.oneOf.0","typeLabel":"string"},{"type":"null","description":"The unique identifier assigned by QuickBooks to this object. This ID is unique across all objects of the same type, but not across different QuickBooks object types.","example":"80000001-1234567890","isRequired":true,"uniqueKey":"documentTemplate.oneOf.0.id.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"documentTemplate.oneOf.0.id","typeLabel":"string | null"},"fullName":{"oneOf":[{"type":"string","description":"The fully-qualified unique name for this object, formed by combining the names of its parent objects with its own `name`, separated by colons. Not case-sensitive.","example":"Parent:Child:Grandchild","isRequired":true,"uniqueKey":"documentTemplate.oneOf.0.fullName.oneOf.0","typeLabel":"string"},{"type":"null","description":"The fully-qualified unique name for this object, formed by combining the names of its parent objects with its own `name`, separated by colons. Not case-sensitive.","example":"Parent:Child:Grandchild","isRequired":true,"uniqueKey":"documentTemplate.oneOf.0.fullName.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"documentTemplate.oneOf.0.fullName","typeLabel":"string | null"}},"additionalProperties":false,"isRequired":true,"uniqueKey":"documentTemplate.oneOf.0","typeLabel":"object"},{"type":"null","description":"The predefined template in QuickBooks that determines the layout and formatting for this sales order when printed or displayed.","example":{"id":"80000001-1234567890","fullName":"Sales Order Template"},"isRequired":true,"uniqueKey":"documentTemplate.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"documentTemplate","typeLabel":"object | null"},"transactionDate":{"type":"string","format":"date","description":"The date of this sales order, in ISO 8601 format (YYYY-MM-DD).","example":"2024-10-01","isRequired":true,"uniqueKey":"transactionDate","typeLabel":"string\u003cdate>"},"refNumber":{"oneOf":[{"type":"string","description":"The case-sensitive user-defined reference number for this sales order, which can be used to identify the transaction in QuickBooks. This value is not required to be unique and can be arbitrarily changed by the QuickBooks user.","example":"SO-1234","isRequired":true,"uniqueKey":"refNumber.oneOf.0","typeLabel":"string"},{"type":"null","description":"The case-sensitive user-defined reference number for this sales order, which can be used to identify the transaction in QuickBooks. This value is not required to be unique and can be arbitrarily changed by the QuickBooks user.","example":"SO-1234","isRequired":true,"uniqueKey":"refNumber.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"refNumber","typeLabel":"string | null"},"billingAddress":{"oneOf":[{"type":"object","title":"The Address object","description":"The sales order's billing address.","required":["line1","line2","line3","line4","line5","city","state","postalCode","country","note"],"x-conductor-object-type":"nested","properties":{"line1":{"oneOf":[{"type":"string","description":"The first line of the address (e.g., street, PO Box, or company name).","example":"Conductor Labs Inc.","isRequired":true,"uniqueKey":"billingAddress.oneOf.0.line1.oneOf.0","typeLabel":"string"},{"type":"null","description":"The first line of the address (e.g., street, PO Box, or company name).","example":"Conductor Labs Inc.","isRequired":true,"uniqueKey":"billingAddress.oneOf.0.line1.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"billingAddress.oneOf.0.line1","typeLabel":"string | null"},"line2":{"oneOf":[{"type":"string","description":"The second line of the address, if needed (e.g., apartment, suite, unit, or building).","example":"540 Market St.","isRequired":true,"uniqueKey":"billingAddress.oneOf.0.line2.oneOf.0","typeLabel":"string"},{"type":"null","description":"The second line of the address, if needed (e.g., apartment, suite, unit, or building).","example":"540 Market St.","isRequired":true,"uniqueKey":"billingAddress.oneOf.0.line2.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"billingAddress.oneOf.0.line2","typeLabel":"string | null"},"line3":{"oneOf":[{"type":"string","description":"The third line of the address, if needed.","example":"Suite 100","isRequired":true,"uniqueKey":"billingAddress.oneOf.0.line3.oneOf.0","typeLabel":"string"},{"type":"null","description":"The third line of the address, if needed.","example":"Suite 100","isRequired":true,"uniqueKey":"billingAddress.oneOf.0.line3.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"billingAddress.oneOf.0.line3","typeLabel":"string | null"},"line4":{"oneOf":[{"type":"string","description":"The fourth line of the address, if needed.","example":"","isRequired":true,"uniqueKey":"billingAddress.oneOf.0.line4.oneOf.0","typeLabel":"string"},{"type":"null","description":"The fourth line of the address, if needed.","example":"","isRequired":true,"uniqueKey":"billingAddress.oneOf.0.line4.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"billingAddress.oneOf.0.line4","typeLabel":"string | null"},"line5":{"oneOf":[{"type":"string","description":"The fifth line of the address, if needed.","example":"","isRequired":true,"uniqueKey":"billingAddress.oneOf.0.line5.oneOf.0","typeLabel":"string"},{"type":"null","description":"The fifth line of the address, if needed.","example":"","isRequired":true,"uniqueKey":"billingAddress.oneOf.0.line5.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"billingAddress.oneOf.0.line5","typeLabel":"string | null"},"city":{"oneOf":[{"type":"string","description":"The city, district, suburb, town, or village name of the address.","example":"San Francisco","isRequired":true,"uniqueKey":"billingAddress.oneOf.0.city.oneOf.0","typeLabel":"string"},{"type":"null","description":"The city, district, suburb, town, or village name of the address.","example":"San Francisco","isRequired":true,"uniqueKey":"billingAddress.oneOf.0.city.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"billingAddress.oneOf.0.city","typeLabel":"string | null"},"state":{"oneOf":[{"type":"string","description":"The state, county, province, or region name of the address.","example":"CA","isRequired":true,"uniqueKey":"billingAddress.oneOf.0.state.oneOf.0","typeLabel":"string"},{"type":"null","description":"The state, county, province, or region name of the address.","example":"CA","isRequired":true,"uniqueKey":"billingAddress.oneOf.0.state.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"billingAddress.oneOf.0.state","typeLabel":"string | null"},"postalCode":{"oneOf":[{"type":"string","description":"The postal code or ZIP code of the address.","example":"94110","isRequired":true,"uniqueKey":"billingAddress.oneOf.0.postalCode.oneOf.0","typeLabel":"string"},{"type":"null","description":"The postal code or ZIP code of the address.","example":"94110","isRequired":true,"uniqueKey":"billingAddress.oneOf.0.postalCode.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"billingAddress.oneOf.0.postalCode","typeLabel":"string | null"},"country":{"oneOf":[{"type":"string","description":"The country name of the address.","example":"United States","isRequired":true,"uniqueKey":"billingAddress.oneOf.0.country.oneOf.0","typeLabel":"string"},{"type":"null","description":"The country name of the address.","example":"United States","isRequired":true,"uniqueKey":"billingAddress.oneOf.0.country.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"billingAddress.oneOf.0.country","typeLabel":"string | null"},"note":{"oneOf":[{"type":"string","description":"A note written at the bottom of the address in the form in which it appears, such as the invoice form.","example":"Conductor HQ","isRequired":true,"uniqueKey":"billingAddress.oneOf.0.note.oneOf.0","typeLabel":"string"},{"type":"null","description":"A note written at the bottom of the address in the form in which it appears, such as the invoice form.","example":"Conductor HQ","isRequired":true,"uniqueKey":"billingAddress.oneOf.0.note.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"billingAddress.oneOf.0.note","typeLabel":"string | null"}},"additionalProperties":false,"isRequired":true,"uniqueKey":"billingAddress.oneOf.0","typeLabel":"The Address object · object"},{"type":"null","description":"The sales order's billing address.","isRequired":true,"uniqueKey":"billingAddress.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"billingAddress","typeLabel":"The Address object · object | null"},"shippingAddress":{"oneOf":[{"type":"object","title":"The Address object","description":"The sales order's shipping address.","required":["line1","line2","line3","line4","line5","city","state","postalCode","country","note"],"x-conductor-object-type":"nested","properties":{"line1":{"oneOf":[{"type":"string","description":"The first line of the address (e.g., street, PO Box, or company name).","example":"Conductor Labs Inc.","isRequired":true,"uniqueKey":"shippingAddress.oneOf.0.line1.oneOf.0","typeLabel":"string"},{"type":"null","description":"The first line of the address (e.g., street, PO Box, or company name).","example":"Conductor Labs Inc.","isRequired":true,"uniqueKey":"shippingAddress.oneOf.0.line1.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"shippingAddress.oneOf.0.line1","typeLabel":"string | null"},"line2":{"oneOf":[{"type":"string","description":"The second line of the address, if needed (e.g., apartment, suite, unit, or building).","example":"540 Market St.","isRequired":true,"uniqueKey":"shippingAddress.oneOf.0.line2.oneOf.0","typeLabel":"string"},{"type":"null","description":"The second line of the address, if needed (e.g., apartment, suite, unit, or building).","example":"540 Market St.","isRequired":true,"uniqueKey":"shippingAddress.oneOf.0.line2.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"shippingAddress.oneOf.0.line2","typeLabel":"string | null"},"line3":{"oneOf":[{"type":"string","description":"The third line of the address, if needed.","example":"Suite 100","isRequired":true,"uniqueKey":"shippingAddress.oneOf.0.line3.oneOf.0","typeLabel":"string"},{"type":"null","description":"The third line of the address, if needed.","example":"Suite 100","isRequired":true,"uniqueKey":"shippingAddress.oneOf.0.line3.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"shippingAddress.oneOf.0.line3","typeLabel":"string | null"},"line4":{"oneOf":[{"type":"string","description":"The fourth line of the address, if needed.","example":"","isRequired":true,"uniqueKey":"shippingAddress.oneOf.0.line4.oneOf.0","typeLabel":"string"},{"type":"null","description":"The fourth line of the address, if needed.","example":"","isRequired":true,"uniqueKey":"shippingAddress.oneOf.0.line4.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"shippingAddress.oneOf.0.line4","typeLabel":"string | null"},"line5":{"oneOf":[{"type":"string","description":"The fifth line of the address, if needed.","example":"","isRequired":true,"uniqueKey":"shippingAddress.oneOf.0.line5.oneOf.0","typeLabel":"string"},{"type":"null","description":"The fifth line of the address, if needed.","example":"","isRequired":true,"uniqueKey":"shippingAddress.oneOf.0.line5.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"shippingAddress.oneOf.0.line5","typeLabel":"string | null"},"city":{"oneOf":[{"type":"string","description":"The city, district, suburb, town, or village name of the address.","example":"San Francisco","isRequired":true,"uniqueKey":"shippingAddress.oneOf.0.city.oneOf.0","typeLabel":"string"},{"type":"null","description":"The city, district, suburb, town, or village name of the address.","example":"San Francisco","isRequired":true,"uniqueKey":"shippingAddress.oneOf.0.city.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"shippingAddress.oneOf.0.city","typeLabel":"string | null"},"state":{"oneOf":[{"type":"string","description":"The state, county, province, or region name of the address.","example":"CA","isRequired":true,"uniqueKey":"shippingAddress.oneOf.0.state.oneOf.0","typeLabel":"string"},{"type":"null","description":"The state, county, province, or region name of the address.","example":"CA","isRequired":true,"uniqueKey":"shippingAddress.oneOf.0.state.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"shippingAddress.oneOf.0.state","typeLabel":"string | null"},"postalCode":{"oneOf":[{"type":"string","description":"The postal code or ZIP code of the address.","example":"94110","isRequired":true,"uniqueKey":"shippingAddress.oneOf.0.postalCode.oneOf.0","typeLabel":"string"},{"type":"null","description":"The postal code or ZIP code of the address.","example":"94110","isRequired":true,"uniqueKey":"shippingAddress.oneOf.0.postalCode.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"shippingAddress.oneOf.0.postalCode","typeLabel":"string | null"},"country":{"oneOf":[{"type":"string","description":"The country name of the address.","example":"United States","isRequired":true,"uniqueKey":"shippingAddress.oneOf.0.country.oneOf.0","typeLabel":"string"},{"type":"null","description":"The country name of the address.","example":"United States","isRequired":true,"uniqueKey":"shippingAddress.oneOf.0.country.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"shippingAddress.oneOf.0.country","typeLabel":"string | null"},"note":{"oneOf":[{"type":"string","description":"A note written at the bottom of the address in the form in which it appears, such as the invoice form.","example":"Conductor HQ","isRequired":true,"uniqueKey":"shippingAddress.oneOf.0.note.oneOf.0","typeLabel":"string"},{"type":"null","description":"A note written at the bottom of the address in the form in which it appears, such as the invoice form.","example":"Conductor HQ","isRequired":true,"uniqueKey":"shippingAddress.oneOf.0.note.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"shippingAddress.oneOf.0.note","typeLabel":"string | null"}},"additionalProperties":false,"isRequired":true,"uniqueKey":"shippingAddress.oneOf.0","typeLabel":"The Address object · object"},{"type":"null","description":"The sales order's shipping address.","isRequired":true,"uniqueKey":"shippingAddress.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"shippingAddress","typeLabel":"The Address object · object | null"},"purchaseOrderNumber":{"oneOf":[{"type":"string","description":"The customer's Purchase Order (PO) number associated with this sales order. This field is often used to cross-reference the sales order with the customer's purchasing system.","example":"PO-1234","isRequired":true,"uniqueKey":"purchaseOrderNumber.oneOf.0","typeLabel":"string"},{"type":"null","description":"The customer's Purchase Order (PO) number associated with this sales order. This field is often used to cross-reference the sales order with the customer's purchasing system.","example":"PO-1234","isRequired":true,"uniqueKey":"purchaseOrderNumber.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"purchaseOrderNumber","typeLabel":"string | null"},"terms":{"oneOf":[{"type":"object","description":"The sales order's payment terms, defining when payment is due and any applicable discounts.","required":["id","fullName"],"example":{"id":"80000001-1234567890","fullName":"Net 30"},"properties":{"id":{"oneOf":[{"type":"string","description":"The unique identifier assigned by QuickBooks to this object. This ID is unique across all objects of the same type, but not across different QuickBooks object types.","example":"80000001-1234567890","isRequired":true,"uniqueKey":"terms.oneOf.0.id.oneOf.0","typeLabel":"string"},{"type":"null","description":"The unique identifier assigned by QuickBooks to this object. This ID is unique across all objects of the same type, but not across different QuickBooks object types.","example":"80000001-1234567890","isRequired":true,"uniqueKey":"terms.oneOf.0.id.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"terms.oneOf.0.id","typeLabel":"string | null"},"fullName":{"oneOf":[{"type":"string","description":"The fully-qualified unique name for this object, formed by combining the names of its parent objects with its own `name`, separated by colons. Not case-sensitive.","example":"Parent:Child:Grandchild","isRequired":true,"uniqueKey":"terms.oneOf.0.fullName.oneOf.0","typeLabel":"string"},{"type":"null","description":"The fully-qualified unique name for this object, formed by combining the names of its parent objects with its own `name`, separated by colons. Not case-sensitive.","example":"Parent:Child:Grandchild","isRequired":true,"uniqueKey":"terms.oneOf.0.fullName.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"terms.oneOf.0.fullName","typeLabel":"string | null"}},"additionalProperties":false,"isRequired":true,"uniqueKey":"terms.oneOf.0","typeLabel":"object"},{"type":"null","description":"The sales order's payment terms, defining when payment is due and any applicable discounts.","example":{"id":"80000001-1234567890","fullName":"Net 30"},"isRequired":true,"uniqueKey":"terms.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"terms","typeLabel":"object | null"},"dueDate":{"oneOf":[{"type":"string","description":"The date by which this sales order must be paid, in ISO 8601 format (YYYY-MM-DD).","format":"date","example":"2024-10-31T00:00:00.000Z","isRequired":true,"uniqueKey":"dueDate.oneOf.0","typeLabel":"string\u003cdate>"},{"type":"null","description":"The date by which this sales order must be paid, in ISO 8601 format (YYYY-MM-DD).","example":"2024-10-31T00:00:00.000Z","isRequired":true,"uniqueKey":"dueDate.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"dueDate","typeLabel":"string\u003cdate> | null"},"salesRepresentative":{"oneOf":[{"type":"object","description":"The sales order's sales representative. Sales representatives can be employees, vendors, or other names in QuickBooks.","required":["id","fullName"],"example":{"id":"80000001-1234567890","fullName":"Jane Doe"},"properties":{"id":{"oneOf":[{"type":"string","description":"The unique identifier assigned by QuickBooks to this object. This ID is unique across all objects of the same type, but not across different QuickBooks object types.","example":"80000001-1234567890","isRequired":true,"uniqueKey":"salesRepresentative.oneOf.0.id.oneOf.0","typeLabel":"string"},{"type":"null","description":"The unique identifier assigned by QuickBooks to this object. This ID is unique across all objects of the same type, but not across different QuickBooks object types.","example":"80000001-1234567890","isRequired":true,"uniqueKey":"salesRepresentative.oneOf.0.id.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"salesRepresentative.oneOf.0.id","typeLabel":"string | null"},"fullName":{"oneOf":[{"type":"string","description":"The fully-qualified unique name for this object, formed by combining the names of its parent objects with its own `name`, separated by colons. Not case-sensitive.","example":"Parent:Child:Grandchild","isRequired":true,"uniqueKey":"salesRepresentative.oneOf.0.fullName.oneOf.0","typeLabel":"string"},{"type":"null","description":"The fully-qualified unique name for this object, formed by combining the names of its parent objects with its own `name`, separated by colons. Not case-sensitive.","example":"Parent:Child:Grandchild","isRequired":true,"uniqueKey":"salesRepresentative.oneOf.0.fullName.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"salesRepresentative.oneOf.0.fullName","typeLabel":"string | null"}},"additionalProperties":false,"isRequired":true,"uniqueKey":"salesRepresentative.oneOf.0","typeLabel":"object"},{"type":"null","description":"The sales order's sales representative. Sales representatives can be employees, vendors, or other names in QuickBooks.","example":{"id":"80000001-1234567890","fullName":"Jane Doe"},"isRequired":true,"uniqueKey":"salesRepresentative.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"salesRepresentative","typeLabel":"object | null"},"shipmentOrigin":{"oneOf":[{"type":"string","description":"The origin location from where the product associated with this sales order is shipped. This is the point at which ownership and liability for goods transfer from seller to buyer. Internally, QuickBooks uses the term \"FOB\" for this field, which stands for \"freight on board\". This field is informational and has no accounting implications.","example":"San Francisco, CA","isRequired":true,"uniqueKey":"shipmentOrigin.oneOf.0","typeLabel":"string"},{"type":"null","description":"The origin location from where the product associated with this sales order is shipped. This is the point at which ownership and liability for goods transfer from seller to buyer. Internally, QuickBooks uses the term \"FOB\" for this field, which stands for \"freight on board\". This field is informational and has no accounting implications.","example":"San Francisco, CA","isRequired":true,"uniqueKey":"shipmentOrigin.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"shipmentOrigin","typeLabel":"string | null"},"shippingDate":{"oneOf":[{"type":"string","description":"The date when the products or services for this sales order were shipped or are expected to be shipped, in ISO 8601 format (YYYY-MM-DD).","format":"date","example":"2024-10-01T00:00:00.000Z","isRequired":true,"uniqueKey":"shippingDate.oneOf.0","typeLabel":"string\u003cdate>"},{"type":"null","description":"The date when the products or services for this sales order were shipped or are expected to be shipped, in ISO 8601 format (YYYY-MM-DD).","example":"2024-10-01T00:00:00.000Z","isRequired":true,"uniqueKey":"shippingDate.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"shippingDate","typeLabel":"string\u003cdate> | null"},"shippingMethod":{"oneOf":[{"type":"object","description":"The shipping method used for this sales order, such as standard mail or overnight delivery.","required":["id","fullName"],"example":{"id":"80000001-1234567890","fullName":"FedEx Ground"},"properties":{"id":{"oneOf":[{"type":"string","description":"The unique identifier assigned by QuickBooks to this object. This ID is unique across all objects of the same type, but not across different QuickBooks object types.","example":"80000001-1234567890","isRequired":true,"uniqueKey":"shippingMethod.oneOf.0.id.oneOf.0","typeLabel":"string"},{"type":"null","description":"The unique identifier assigned by QuickBooks to this object. This ID is unique across all objects of the same type, but not across different QuickBooks object types.","example":"80000001-1234567890","isRequired":true,"uniqueKey":"shippingMethod.oneOf.0.id.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"shippingMethod.oneOf.0.id","typeLabel":"string | null"},"fullName":{"oneOf":[{"type":"string","description":"The fully-qualified unique name for this object, formed by combining the names of its parent objects with its own `name`, separated by colons. Not case-sensitive.","example":"Parent:Child:Grandchild","isRequired":true,"uniqueKey":"shippingMethod.oneOf.0.fullName.oneOf.0","typeLabel":"string"},{"type":"null","description":"The fully-qualified unique name for this object, formed by combining the names of its parent objects with its own `name`, separated by colons. Not case-sensitive.","example":"Parent:Child:Grandchild","isRequired":true,"uniqueKey":"shippingMethod.oneOf.0.fullName.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"shippingMethod.oneOf.0.fullName","typeLabel":"string | null"}},"additionalProperties":false,"isRequired":true,"uniqueKey":"shippingMethod.oneOf.0","typeLabel":"object"},{"type":"null","description":"The shipping method used for this sales order, such as standard mail or overnight delivery.","example":{"id":"80000001-1234567890","fullName":"FedEx Ground"},"isRequired":true,"uniqueKey":"shippingMethod.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"shippingMethod","typeLabel":"object | null"},"subtotal":{"type":"string","description":"The subtotal of this sales order, which is the sum of all sales order lines before taxes and payments are applied, represented as a decimal string.","example":"1000.00","isRequired":true,"uniqueKey":"subtotal","typeLabel":"string"},"salesTaxItem":{"oneOf":[{"type":"object","description":"The sales-tax item used to calculate the actual tax amount for this sales order's transactions by applying a specific tax rate collected for a single tax agency. Unlike `salesTaxCode`, which only indicates general taxability, this field drives the actual tax calculation and reporting.","required":["id","fullName"],"example":{"id":"80000001-1234567890","fullName":"State Sales Tax"},"properties":{"id":{"oneOf":[{"type":"string","description":"The unique identifier assigned by QuickBooks to this object. This ID is unique across all objects of the same type, but not across different QuickBooks object types.","example":"80000001-1234567890","isRequired":true,"uniqueKey":"salesTaxItem.oneOf.0.id.oneOf.0","typeLabel":"string"},{"type":"null","description":"The unique identifier assigned by QuickBooks to this object. This ID is unique across all objects of the same type, but not across different QuickBooks object types.","example":"80000001-1234567890","isRequired":true,"uniqueKey":"salesTaxItem.oneOf.0.id.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"salesTaxItem.oneOf.0.id","typeLabel":"string | null"},"fullName":{"oneOf":[{"type":"string","description":"The fully-qualified unique name for this object, formed by combining the names of its parent objects with its own `name`, separated by colons. Not case-sensitive.","example":"Parent:Child:Grandchild","isRequired":true,"uniqueKey":"salesTaxItem.oneOf.0.fullName.oneOf.0","typeLabel":"string"},{"type":"null","description":"The fully-qualified unique name for this object, formed by combining the names of its parent objects with its own `name`, separated by colons. Not case-sensitive.","example":"Parent:Child:Grandchild","isRequired":true,"uniqueKey":"salesTaxItem.oneOf.0.fullName.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"salesTaxItem.oneOf.0.fullName","typeLabel":"string | null"}},"additionalProperties":false,"isRequired":true,"uniqueKey":"salesTaxItem.oneOf.0","typeLabel":"object"},{"type":"null","description":"The sales-tax item used to calculate the actual tax amount for this sales order's transactions by applying a specific tax rate collected for a single tax agency. Unlike `salesTaxCode`, which only indicates general taxability, this field drives the actual tax calculation and reporting.","example":{"id":"80000001-1234567890","fullName":"State Sales Tax"},"isRequired":true,"uniqueKey":"salesTaxItem.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"salesTaxItem","typeLabel":"object | null"},"salesTaxPercentage":{"oneOf":[{"type":"string","description":"The sales tax percentage applied to this sales order, represented as a decimal string.","example":"0.07","isRequired":true,"uniqueKey":"salesTaxPercentage.oneOf.0","typeLabel":"string"},{"type":"null","description":"The sales tax percentage applied to this sales order, represented as a decimal string.","example":"0.07","isRequired":true,"uniqueKey":"salesTaxPercentage.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"salesTaxPercentage","typeLabel":"string | null"},"salesTaxTotal":{"oneOf":[{"type":"string","description":"The total amount of sales tax charged for this sales order, represented as a decimal string.","example":"10.00","isRequired":true,"uniqueKey":"salesTaxTotal.oneOf.0","typeLabel":"string"},{"type":"null","description":"The total amount of sales tax charged for this sales order, represented as a decimal string.","example":"10.00","isRequired":true,"uniqueKey":"salesTaxTotal.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"salesTaxTotal","typeLabel":"string | null"},"totalAmount":{"type":"string","description":"The total monetary amount of this sales order, equivalent to the sum of the amounts in `lines` and `lineGroups`, represented as a decimal string.","example":"1000.00","isRequired":true,"uniqueKey":"totalAmount","typeLabel":"string"},"currency":{"oneOf":[{"type":"object","description":"The sales order's currency. For built-in currencies, the name and code are standard ISO 4217 international values. For user-defined currencies, all values are editable.","required":["id","fullName"],"example":{"id":"80000001-1234567890","fullName":"USD"},"properties":{"id":{"oneOf":[{"type":"string","description":"The unique identifier assigned by QuickBooks to this object. This ID is unique across all objects of the same type, but not across different QuickBooks object types.","example":"80000001-1234567890","isRequired":true,"uniqueKey":"currency.oneOf.0.id.oneOf.0","typeLabel":"string"},{"type":"null","description":"The unique identifier assigned by Qu
[...]
